﻿using System;
using System.Activities;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Workflow;

namespace SonomaPartners.Xrm.Workflow.Utilities
{
	public class FormatLineBreaks : CodeActivity
	{
		protected override void Execute(CodeActivityContext executionContext)
		{
			// Get the context service.
			IWorkflowContext context = executionContext.GetExtension<IWorkflowContext>();

			// Get the record id
			Guid id = context.PrimaryEntityId;

			string inputValue = InputValue.Get<string>(executionContext);
			string formattedValue = (inputValue != null) ? inputValue.Replace("\n", "<br>") : string.Empty;

			// Configure the various output parameters
			FormattedValue.Set(executionContext, formattedValue);
		}

		[Input("Input Value")]
		[Default("")]
		public InArgument<string> InputValue { get; set; }

		[Output("Formatted Value")]
		[Default("")]
		public OutArgument<string> FormattedValue { get; set; }
	}
}