﻿using System;
using System.Activities;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Workflow;

namespace SonomaPartners.Xrm.Workflow.Utilities
{
	public class UrlBuilder : CodeActivity
	{
		protected override void Execute(CodeActivityContext executionContext)
		{
			// Get the context service.
			IWorkflowContext context = executionContext.GetExtension<IWorkflowContext>();

			// Get the record id
			Guid id = context.PrimaryEntityId;

			// Configure the various output parameters
			EntityId.Set(executionContext, id.ToString());

			string fullUrl = string.Format(InputUrl.Get<string>(executionContext), id.ToString());
			OutputUrl.Set(executionContext, fullUrl);

			string formattedUrl = string.Format(@"<a href=""{0}"">{0}</a>", fullUrl);
			FormattedUrl.Set(executionContext, formattedUrl);
		}

		[Input("Input Url")]
		[Default("http://server/org/main.aspx?etn=entity&pagetype=entityrecord&id={0}")]
		public InArgument<string> InputUrl { get; set; }

		[Output("Entity Id")]
		[Default("")]
		public OutArgument<string> EntityId { get; set; }

		[Output("Output Url")]
		[Default("")]
		public OutArgument<string> OutputUrl { get; set; }

		[Output("Formatted Url")]
		[Default("")]
		public OutArgument<string> FormattedUrl { get; set; }
	}
}
