// Retrieve customer telephone number
function retrieveCustomerTelephone() {

	var customerAttribute = parent.Xrm.Page.data.entity.attributes.get("customerid");

	if (customerAttribute != null) {
		customerValue = customerAttribute.getValue();

		if (customerValue != null && customerValue[0] != null) {
			var customerType = customerValue[0].typename;
			var customerId = customerValue[0].id;

			switch (customerType) {
				case "account":
					{
						return retrieveRecord(customerId, "AccountSet", retrieveCompleted, null);
					}
					break;
				case "contact":
					{
						return retrieveRecord(customerId, "ContactSet", retrieveCompleted, null);
					}
					break;
			}
		}
	}
}

function retrieveRecord(id, odataSetName, successCallback, errorCallback) {
	var context = GetGlobalContext();
	var serverUrl = context.getServerUrl();

	//The XRM OData end-point
	var odataEndPoint = "/XRMServices/2011/OrganizationData.svc";

	//id is required
	if (!id) {
		alert("record id is required.");
		return;
	}
	//odataSetName is required, i.e. "AccountSet"
	if (!odataSetName) {
		alert("odataSetName is required.");
		return;
	}

	//Asynchronous AJAX function to Retrieve a CRM record using OData
	$.ajax({
		type: "GET",
		contentType: "application/json; charset=utf-8",
		datatype: "json",
		url: serverUrl + odataEndPoint + "/" + odataSetName + "(guid'" + id + "')",
		beforeSend: function (XMLHttpRequest) {
			//Specifying this header ensures that the results will be returned as JSON.             
			XMLHttpRequest.setRequestHeader("Accept", "application/json");
		},
		success: function (data, textStatus, XmlHttpRequest) {
			if (successCallback) {
				successCallback(data.d, textStatus, XmlHttpRequest);
			}
		},
		error: function (XmlHttpRequest, textStatus, errorThrown) {
			if (errorCallback)
				errorCallback(XmlHttpRequest, textStatus, errorThrown);
			else
				errorHandler(XmlHttpRequest, textStatus, errorThrown);
		}
	});
}


function retrieveCompleted(data, textStatus, XmlHttpRequest) {

	//Get back the entity JSON object
	var entity = data;

	return (entity.Telephone1 == null) ? "" : entity.Telephone1;
}